既存のコレクションにフィールドを追加する
Milvusでは、既存のコレクションに新しいフィールドを動的に追加できます。これにより、アプリケーションの要件変化に応じてデータスキーマを柔軟に進化させることができます。このガイドでは、実用的な例を用いてさまざまなシナリオでのフィールド追加方法を紹介します。
注意事項
コレクションにフィールドを追加する前に、以下の重要なポイントを確認してください:
-
スカラーフィールド(
INT64、VARCHAR、FLOAT、DOUBLEなど)を追加できます。ベクターフィールドは既存のコレクションに追加できません。 -
新しいフィールドは、新しいフィールドの値を持たない既存のエンティティに対応するため、nullable(nullable=True)である必要があります。
-
ロード済みのコレクションにフィールドを追加すると、メモリ使用量が増加します。
-
コレクションごとのフィールド総数には上限があります。詳細については、Milvus 制限s を参照してください。
-
フィールド名は静的フィールド内で一意である必要があります。
-
最初に
enable_dynamic_field=Trueを指定せずに作成されたコレクションに対して、後から$metaフィールドを追加して動的フィールド機能を有効にすることはできません。
前提条件
このガイドでは、以下の環境が整っていることを前提としています:
-
実行中の Milvus インスタンス
-
Milvus SDK がインストール済み
-
既存のコレクション
コレクションの作成および基本操作については、Create Collection を参照してください。
基本的な使い方
- Python
- Java
- NodeJS
- Go
- cURL
from pymilvus import MilvusClient, DataType
# Connect to your Milvus server
client = MilvusClient(
uri="YOUR_CLUSTER_ENDPOINT" # Replace with your Milvus server URI
)
import io.milvus.v2.client.MilvusClientV2;
import io.milvus.v2.client.ConnectConfig;
ConnectConfig config = ConnectConfig.builder()
.uri("YOUR_CLUSTER_ENDPOINT")
.build();
MilvusClientV2 client = new MilvusClientV2(config);
import { MilvusClient } from '@zilliz/milvus2-sdk-node';
const milvusClient = new MilvusClient({
address: 'YOUR_CLUSTER_ENDPOINT'
});
// go
# restful
export CLUSTER_ENDPOINT="YOUR_CLUSTER_ENDPOINT"
シナリオ 1: Null 許容フィールドを迅速に追加する
コレクションを拡張する最も簡単な方法は、Null 許容フィールドを追加することです。これは、データに新しい属性を素早く追加したい場合に最適です。
- Python
- Java
- NodeJS
- Go
- cURL
# Add a nullable field to an existing collection
# This operation:
# - Returns almost immediately (non-blocking)
# - Makes the field available for use with minimal delay
# - Sets NULL for all existing entities
client.add_collection_field(
collection_name="product_catalog",
field_name="created_timestamp", # Name of the new field to add
data_type=DataType.INT64, # Data type must be a scalar type
nullable=True # Must be True for added fields
# Allows NULL values for existing entities
)
import io.milvus.v2.service.collection.request.AddCollectionFieldReq;
client.addCollectionField(AddCollectionFieldReq.builder()
.collectionName("product_catalog")
.fieldName("created_timestamp")
.dataType(DataType.Int64)
.isNullable(true)
.build());
await client.addCollectionField({
collection_name: 'product_catalog',
field: {
name: 'created_timestamp',
dataType: 'Int64',
nullable: true
}
});
// go
# restful
curl -X POST "YOUR_CLUSTER_ENDPOINT/v2/vectordb/collections/fields/add" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer <token>" \
-d '{
"collectionName": "product_catalog",
"schema": {
"fieldName": "created_timestamp",
"dataType": "Int64",
"nullable": true
}
}'
期待される動作:
-
既存のエンティティは、新しいフィールドに対して NULL を持つ
-
新しいエンティティは、NULL または実際の値のいずれかを持つことができる
-
フィールドの可用性は、内部スキーマ同期により、ほぼ即座に(最小限の遅延で)発生する
-
同期期間が短時間経過した後、即時クエリ可能となる
- Python
- Java
- NodeJS
- Go
- cURL
# Example query result
{
'id': 1,
'created_timestamp': None # New field shows NULL for existing entities
}
// java
// nodejs
{
'id': 1,
'created_timestamp': None # New field shows NULL for existing entities
}
// go
# restful
{
"code": 0,
"data": {},
"cost": 0
}
シナリオ 2: デフォルト値を持つフィールドを追加する
既存のエンティティに NULL ではなく意味のある初期値を持たせたい場合は、デフォルト値を指定します。
- Python
- Java
- NodeJS
- Go
- cURL
# Add a field with default value
# This operation:
# - Sets the default value for all existing entities
# - Makes the field available with minimal delay
# - Maintains data consistency with the default value
client.add_collection_field(
collection_name="product_catalog",
field_name="priority_level", # Name of the new field
data_type=DataType.VARCHAR, # String type field
max_length=20, # Maximum string length
nullable=True, # Required for added fields
default_value="standard" # Value assigned to existing entities
# Also used for new entities if no value provided
)
client.addCollectionField(AddCollectionFieldReq.builder()
.collectionName("product_catalog")
.fieldName("priority_level")
.dataType(DataType.VarChar)
.maxLength(20)
.isNullable(true)
.build());
await client.addCollectionField({
collection_name: 'product_catalog',
field: {
name: 'priority_level',
dataType: 'VarChar',
nullable: true,
default_value: 'standard',
}
});
// go
# restful
curl -X POST "YOUR_CLUSTER_ENDPOINT/v2/vectordb/collections/fields/add" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer <token>" \
-d '{
"collectionName": "product_catalog",
"schema": {
"fieldName": "priority_level",
"dataType": "VarChar",
"nullable": true,
"defaultValue": "standard",
"elementTypeParams": {
"max_length": "20"
}
}
}'
期待される動作:
-
既存のエンティティは、新しく追加されたフィールドに対してデフォルト値(
"standard")を持つことになります。 -
新しいエンティティは、デフォルト値を上書きすることも、値が指定されない場合はそのデフォルト値を使用することもできます。
-
フィールドの可用性は、ごくわずかな遅延でほぼ即座に発生します。
-
短い同期期間の後、すぐに即時クエリ可能になります。
- Python
- Java
- NodeJS
- Go
- cURL
# Example query result
{
'id': 1,
'priority_level': 'standard' # Shows default value for existing entities
}
// java
{
'id': 1,
'priority_level': 'standard' # Shows default value for existing entities
}
// go
# restful
{
'id': 1,
'priority_level': 'standard' # Shows default value for existing entities
}
FAQ
$meta フィールドを追加することで動的スキーマ機能を有効にできますか?
いいえ、add_collection_field を使用して $meta フィールドを追加し、動的フィールド機能を有効にすることはできません。たとえば、以下のコードは動作しません:
- Python
- Java
- NodeJS
- Go
- cURL
# ❌ This is NOT supported
client.add_collection_field(
collection_name="existing_collection",
field_name="$meta",
data_type=DataType.JSON # This operation will fail
)
// ❌ This is NOT supported
client.addCollectionField(AddCollectionFieldReq.builder()
.collectionName("existing_collection")
.fieldName("$meta")
.dataType(DataType.JSON)
.build());
// ❌ This is NOT supported
await client.addCollectionField({
collection_name: 'product_catalog',
field: {
name: '$meta',
dataType: 'JSON',
}
});
// go
# restful
# ❌ This is NOT supported
curl -X POST "YOUR_CLUSTER_ENDPOINT/v2/vectordb/collections/fields/add" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer <token>" \
-d '{
"collectionName": "existing_collection",
"schema": {
"fieldName": "$meta",
"dataType": "JSON",
"nullable": true
}
}'
動的スキーマ機能を有効にするには、以下の手順に従います。
-
新しいコレクション: コレクション作成時に
enable_dynamic_fieldを True に設定します。詳細については、コレクションの作成を参照してください。 -
既存のコレクション: コレクションレベルのプロパティ
dynamicfield.enabledを True に設定します。詳細については、コレクションの変更を参照してください。
動的フィールドキーと同じ名前のフィールドを追加するとどうなりますか?
コレクションで動的フィールドが有効になっている場合($meta が存在する)、既存の動的フィールドキーと同じ名前を持つ静的フィールドを追加できます。この場合、新たに追加された静的フィールドが動的フィールドキーをマスクしますが、元の動的データは保持されます。
フィールド名の競合を避けるため、実際にフィールドを追加する前に、既存のフィールドおよび動的フィールドキーを確認し、適切な名前を選定することを推奨します。
シナリオ例:
- Python
- Java
- NodeJS
- Go
- cURL
# Original collection with dynamic field enabled
# Insert data with dynamic field keys
data = [{
"id": 1,
"my_vector": [0.1, 0.2, ...],
"extra_info": "this is a dynamic field key", # Dynamic field key as string
"score": 99.5 # Another dynamic field key
}]
client.insert(collection_name="product_catalog", data=data)
# Add static field with same name as existing dynamic field key
client.add_collection_field(
collection_name="product_catalog",
field_name="extra_info", # Same name as dynamic field key
data_type=DataType.INT64, # Data type can differ from dynamic field key
nullable=True # Must be True for added fields
)
# Insert new data after adding static field
new_data = [{
"id": 2,
"my_vector": [0.3, 0.4, ...],
"extra_info": 100, # Now must use INT64 type (static field)
"score": 88.0 # Still a dynamic field key
}]
client.insert(collection_name="product_catalog", data=new_data)
import com.google.gson.*;
import io.milvus.v2.service.vector.request.InsertReq;
import io.milvus.v2.service.vector.response.InsertResp;
Gson gson = new Gson();
JsonObject row = new JsonObject();
row.addProperty("id", 1);
row.add("my_vector", gson.toJsonTree(new float[]{0.1f, 0.2f, ...}));
row.addProperty("extra_info", "this is a dynamic field key");
row.addProperty("score", 99.5);
InsertResp insertR = client.insert(InsertReq.builder()
.collectionName("product_catalog")
.data(Collections.singletonList(row))
.build());
client.addCollectionField(AddCollectionFieldReq.builder()
.collectionName("product_catalog")
.fieldName("extra_info")
.dataType(DataType.Int64)
.isNullable(true)
.build());
JsonObject newRow = new JsonObject();
newRow.addProperty("id", 2);
newRow.add("my_vector", gson.toJsonTree(new float[]{0.3f, 0.4f, ...}));
newRow.addProperty("extra_info", 100);
newRow.addProperty("score", 88.0);
insertR = client.insert(InsertReq.builder()
.collectionName("product_catalog")
.data(Collections.singletonList(newRow))
.build());
// Original collection with dynamic field enabled
// Insert data with dynamic field keys
const data = [{
"id": 1,
"my_vector": [0.1, 0.2, ...],
"extra_info": "this is a dynamic field key", // Dynamic field key as string
"score": 99.5 // Another dynamic field key
}]
await client.insert({
collection_name: "product_catalog",
data: data
});
// Add static field with same name as existing dynamic field key
await client.add_collection_field({
collection_name: "product_catalog",
field_name: "extra_info", // Same name as dynamic field key
data_type: DataType.INT64, // Data type can differ from dynamic field key
nullable: true // Must be True for added fields
});
// Insert new data after adding static field
const new_data = [{
"id": 2,
"my_vector": [0.3, 0.4, ...],
"extra_info": 100, # Now must use INT64 type (static field)
"score": 88.0 # Still a dynamic field key
}];
await client.insert({
collection_name:"product_catalog",
data: new_data
});
// go
# restful
#!/bin/bash
export MILVUS_HOST="YOUR_CLUSTER_ENDPOINT"
export AUTH_TOKEN="your_token_here"
export COLLECTION_NAME="product_catalog"
echo "Step 1: Insert initial data with dynamic fields..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/entities/insert" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"data\": [{
\"id\": 1,
\"my_vector\": [0.1, 0.2, 0.3, 0.4, 0.5],
\"extra_info\": \"this is a dynamic field key\",
\"score\": 99.5
}]
}"
echo -e "\n\nStep 2: Add static field with same name as dynamic field..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/collections/fields/add" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"schema\": {
\"fieldName\": \"extra_info\",
\"dataType\": \"Int64\",
\"nullable\": true
}
}"
echo -e "\n\nStep 3: Insert new data after adding static field..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/entities/insert" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"data\": [{
\"id\": 2,
\"my_vector\": [0.3, 0.4, 0.5, 0.6, 0.7],
\"extra_info\": 100,
\"score\": 88.0
}]
}"
期待される動作:
-
既存のエンティティは、新しい静的フィールド
extra_infoに対して NULL を持つ -
新しいエンティティは、静的フィールドのデータ型(
INT64)を使用する必要がある -
元の動的フィールドのキー値は保持され、
$meta構文を介してアクセス可能 -
静的フィールドは通常のクエリにおいて動的フィールドのキーをマスクする
静的フィールドと動的フィールドの両方の値にアクセスする方法:
- Python
- Java
- NodeJS
- Go
- cURL
# 1. Query static field only (dynamic field key is masked)
results = client.query(
collection_name="product_catalog",
filter="id == 1",
output_fields=["extra_info"]
)
# Returns: {"id": 1, "extra_info": None} # NULL for existing entity
# 2. Query both static and original dynamic values
results = client.query(
collection_name="product_catalog",
filter="id == 1",
output_fields=["extra_info", "$meta['extra_info']"]
)
# Returns: {
# "id": 1,
# "extra_info": None, # Static field value (NULL)
# "$meta['extra_info']": "this is a dynamic field key" # Original dynamic value
# }
# 3. Query new entity with static field value
results = client.query(
collection_name="product_catalog",
filter="id == 2",
output_fields=["extra_info"]
)
# Returns: {"id": 2, "extra_info": 100} # Static field value
// java
// 1. Query static field only (dynamic field key is masked)
let results = client.query({
collection_name: "product_catalog",
filter: "id == 1",
output_fields: ["extra_info"]
})
// Returns: {"id": 1, "extra_info": None} # NULL for existing entity
// 2. Query both static and original dynamic values
results = client.query({
collection_name:"product_catalog",
filter: "id == 1",
output_fields: ["extra_info", "$meta['extra_info']"]
});
// Returns: {
// "id": 1,
// "extra_info": None, # Static field value (NULL)
// "$meta['extra_info']": "this is a dynamic field key" # Original dynamic value
// }
// 3. Query new entity with static field value
results = client.query({
collection_name: "product_catalog",
filter: "id == 2",
output_fields: ["extra_info"]
})
// Returns: {"id": 2, "extra_info": 100} # Static field value
// go
# restful
#!/bin/bash
export MILVUS_HOST="YOUR_CLUSTER_ENDPOINT"
export AUTH_TOKEN="your_token_here"
export COLLECTION_NAME="product_catalog"
echo "Query 1: Static field only (dynamic field masked)..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/entities/query" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"filter\": \"id == 1\",
\"outputFields\": [\"extra_info\"]
}"
echo -e "\n\nQuery 2: Both static and original dynamic values..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/entities/query" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"filter\": \"id == 1\",
\"outputFields\": [\"extra_info\", \"\$meta['extra_info']\"]
}"
echo -e "\n\nQuery 3: New entity with static field value..."
curl -X POST "http://${MILVUS_HOST}/v2/vectordb/entities/query" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${AUTH_TOKEN}" \
-d "{
\"collectionName\": \"${COLLECTION_NAME}\",
\"filter\": \"id == 2\",
\"outputFields\": [\"extra_info\"]
}"
新しいフィールドが利用可能になるまでどのくらい時間がかかりますか?
追加されたフィールドはほぼ即座に利用可能になりますが、Milvusクラスター全体で内部スキーマ変更をブロードキャストする際に、ごく短い遅延が発生する可能性があります。この同期処理により、すべてのノードが新しいフィールドを含むスキーマ更新を認識し、そのフィールドを含むクエリを処理できるようになります。